﻿
// PL2523_6GPIODlg.cpp: 實作檔案
//

#include "pch.h"
#include "framework.h"
#include "PL2523_6GPIO.h"
#include "PL2523_6GPIODlg.h"
#include "afxdialogex.h"
#include <winioctl.h>
#include <dbt.h>
#include "Ioctl.h"
#include <initguid.h>
#include <Hidclass.h>
//#include "..\PL2303DLL\PL2303DLL.h"
#include "inc_PL2303\PL2303DLL.h"

#define PrintLog 0

#ifdef _DEBUG
#define new DEBUG_NEW

#endif


// CPL25236GPIODlg 對話方塊



CPL25236GPIODlg::CPL25236GPIODlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_PL2523_6GPIO_DIALOG, pParent)
	, mv_TX_LED0_edit(0)
	, mv_Rx_LED0_edit(0)
	, mv_TX_LED1_edit(_T("0"))
	, mv_RX_LED1_edit(0)
	, mv_P2_7_edit(0)
	, mv_P2_9_edit(0)
	, mv_P3_10_edit(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPL25236GPIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHK_TX_LED0_CE, mc_TX_LED0_CE);
	DDX_Control(pDX, IDC_CHK_TX_LED0_OE, mc_TX_LED0_OE);
	DDX_Control(pDX, IDC_BTN_Get_TX_LED0, mc_TX_LED0_Get);
	DDX_Control(pDX, IDC_BTN_Set_TX_LED0, mc_TX_LED0_Set);
	DDX_Control(pDX, IDC_EDIT_SetValue_TX_LED0, mc_TX_LED0_edit);
	DDX_Text(pDX, IDC_EDIT_SetValue_TX_LED0, mv_TX_LED0_edit);
	DDX_Control(pDX, IDC_CHK_RX_LED0_CE, mc_RX_LED0_CE);
	DDX_Control(pDX, IDC_CHK_RX_LED0_OE, mc_RX_LED0_OE);
	DDX_Control(pDX, IDC_BTN_Get_RX_LED0, mc_RX_LED0_Get);
	DDX_Control(pDX, IDC_BTN_Set_RX_LED0, mc_RX_LED0_Set);
	DDX_Control(pDX, IDC_EDIT_SetValue_RX_LED0, mc_RX_LED0_edit);
	DDX_Text(pDX, IDC_EDIT_SetValue_RX_LED0, mv_Rx_LED0_edit);
	DDX_Control(pDX, IDC_CHK_TX_LED1_CE, mc_TX_LED1_CE);
	DDX_Control(pDX, IDC_CHK_TX_LED1_OE, mc_TX_LED1_OE);
	DDX_Control(pDX, IDC_BTN_Get_TX_LED1, mc_TX_LED1_Get);
	DDX_Control(pDX, IDC_BTN_Set_TX_LED1, mc_TX_LED1_Set);
	DDX_Control(pDX, IDC_EDIT_SetValue_TX_LED1, mc_TX_LED1_edit);
	DDX_Text(pDX, IDC_EDIT_SetValue_TX_LED1, mv_TX_LED1_edit);
	DDX_Control(pDX, IDC_CHK_TX_LED1_CE2, mc_RX_LED1_CE);
	DDX_Control(pDX, IDC_CHK_TX_LED1_OE2, mc_RX_LED1_OE);
	DDX_Control(pDX, IDC_BTN_Get_TX_LED2, mc_RX_LED1_Get);
	DDX_Control(pDX, IDC_BTN_Set_TX_LED2, mc_RX_LED1_Set);
	DDX_Control(pDX, IDC_EDIT_SetValue_TX_LED2, mc_RX_LED1_edit);
	DDX_Text(pDX, IDC_EDIT_SetValue_TX_LED2, mv_RX_LED1_edit);
	DDX_Control(pDX, IDC_CHK_TX_LED1_CE4, mc_P2_7_CE);
	DDX_Control(pDX, IDC_CHK_TX_LED1_OE4, mc_P2_7_OE);
	DDX_Control(pDX, IDC_BTN_Get_TX_LED4, mc_P2_7_Get);
	DDX_Control(pDX, IDC_BTN_Set_TX_LED4, mc_P2_7_Set);
	DDX_Control(pDX, IDC_EDIT_SetValue_TX_LED4, mc_P2_7_edit);
	DDX_Text(pDX, IDC_EDIT_SetValue_TX_LED4, mv_P2_7_edit);
	DDX_Control(pDX, IDC_CHK_TX_LED1_CE5, mc_P2_9_CE);
	DDX_Control(pDX, IDC_CHK_TX_LED1_OE5, mc_P2_9_OE);
	DDX_Control(pDX, IDC_BTN_Get_TX_LED5, mc_P2_9_Get);
	DDX_Control(pDX, IDC_BTN_Set_TX_LED5, mc_P2_9_Set);
	DDX_Control(pDX, IDC_EDIT_SetValue_TX_LED5, mc_P2_9_edit);
	DDX_Text(pDX, IDC_EDIT_SetValue_TX_LED5, mv_P2_9_edit);
	DDX_Control(pDX, IDC_COMBO_PORT, m_cboDevice);
	DDX_Control(pDX, IDC_BUT_REFRESH, m_Refresh);
	DDX_Control(pDX, IDC_CHK_P3_10_CE, mc_P3_10_CE);
	DDX_Control(pDX, IDC_CHK_P3_10_OE, mc_P3_10_OE);
	DDX_Control(pDX, IDC_BTN_Get_P3_10, mc_P3_10_Get);
	DDX_Control(pDX, IDC_BTN_Set_P3_10, mc_P3_10_Set);
	DDX_Control(pDX, IDC_EDIT_SetValue_P3_10, mc_P3_10_edit);
	DDX_Text(pDX, IDC_EDIT_SetValue_P3_10, mv_P3_10_edit);
}

BEGIN_MESSAGE_MAP(CPL25236GPIODlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_OPEN, &CPL25236GPIODlg::OnBnClickedBtnOpen)
	ON_BN_CLICKED(IDC_BUT_Close, &CPL25236GPIODlg::OnBnClickedButClose)
	ON_BN_CLICKED(IDC_BUTTON_Clear, &CPL25236GPIODlg::OnBnClickedButtonClear)
	ON_BN_CLICKED(IDC_BTN_SETSTATUS, &CPL25236GPIODlg::OnBnClickedBtnSetstatus)
	ON_BN_CLICKED(IDC_BTN_GETSTATUS, &CPL25236GPIODlg::OnBnClickedBtnGetstatus)
	ON_BN_CLICKED(IDC_CHK_TX_LED0_CE, &CPL25236GPIODlg::OnBnClickedChkTxLed0Ce)
	ON_BN_CLICKED(IDC_CHK_TX_LED0_OE, &CPL25236GPIODlg::OnBnClickedChkTxLed0Oe)
	ON_BN_CLICKED(IDC_BTN_Get_TX_LED0, &CPL25236GPIODlg::OnBnClickedBtnGetTxLed0)
	ON_BN_CLICKED(IDC_BTN_Set_TX_LED0, &CPL25236GPIODlg::OnBnClickedBtnSetTxLed0)
	ON_EN_CHANGE(IDC_EDIT_SetValue_TX_LED0, &CPL25236GPIODlg::OnEnChangeEditSetvalueTxLed0)
	ON_BN_CLICKED(IDC_CHK_RX_LED0_CE, &CPL25236GPIODlg::OnBnClickedChkRxLed0Ce)
	ON_BN_CLICKED(IDC_CHK_RX_LED0_OE, &CPL25236GPIODlg::OnBnClickedChkRxLed0Oe)
	ON_BN_CLICKED(IDC_BTN_Get_RX_LED0, &CPL25236GPIODlg::OnBnClickedBtnGetRxLed0)
	ON_BN_CLICKED(IDC_BTN_Set_RX_LED0, &CPL25236GPIODlg::OnBnClickedBtnSetRxLed0)
	ON_BN_CLICKED(IDC_BTN_Set_TX_LED1, &CPL25236GPIODlg::OnBnClickedBtnSetTxLed1)
	ON_BN_CLICKED(IDC_CHK_TX_LED1_CE, &CPL25236GPIODlg::OnBnClickedChkTxLed1Ce)
	ON_BN_CLICKED(IDC_BTN_Get_TX_LED1, &CPL25236GPIODlg::OnBnClickedBtnGetTxLed1)
	ON_BN_CLICKED(IDC_CHK_TX_LED1_OE, &CPL25236GPIODlg::OnBnClickedChkTxLed1Oe)
	ON_BN_CLICKED(IDC_CHK_TX_LED1_CE2, &CPL25236GPIODlg::OnBnClickedChkTxLed1Ce2)
	ON_BN_CLICKED(IDC_CHK_TX_LED1_OE2, &CPL25236GPIODlg::OnBnClickedChkTxLed1Oe2)
	ON_BN_CLICKED(IDC_BTN_Get_TX_LED2, &CPL25236GPIODlg::OnBnClickedBtnGetTxLed2)
	ON_BN_CLICKED(IDC_BTN_Set_TX_LED2, &CPL25236GPIODlg::OnBnClickedBtnSetTxLed2)
	ON_BN_CLICKED(IDC_CHK_TX_LED1_CE4, &CPL25236GPIODlg::OnBnClickedChkTxLed1Ce4)
	ON_BN_CLICKED(IDC_CHK_TX_LED1_OE4, &CPL25236GPIODlg::OnBnClickedChkTxLed1Oe4)
	ON_BN_CLICKED(IDC_BTN_Get_TX_LED4, &CPL25236GPIODlg::OnBnClickedBtnGetTxLed4)
	ON_BN_CLICKED(IDC_BTN_Set_TX_LED4, &CPL25236GPIODlg::OnBnClickedBtnSetTxLed4)
	ON_BN_CLICKED(IDC_CHK_TX_LED1_CE5, &CPL25236GPIODlg::OnBnClickedChkTxLed1Ce5)
	ON_BN_CLICKED(IDC_CHK_TX_LED1_OE5, &CPL25236GPIODlg::OnBnClickedChkTxLed1Oe5)
	ON_BN_CLICKED(IDC_BTN_Get_TX_LED5, &CPL25236GPIODlg::OnBnClickedBtnGetTxLed5)
	ON_BN_CLICKED(IDC_BTN_Set_TX_LED5, &CPL25236GPIODlg::OnBnClickedBtnSetTxLed5)
	ON_CBN_SELCHANGE(IDC_COMBO_PORT, &CPL25236GPIODlg::OnCbnSelchangeComboPort)
	ON_BN_CLICKED(IDC_BUT_REFRESH, &CPL25236GPIODlg::OnBnClickedButRefresh)
	ON_BN_CLICKED(IDC_BUTTON1, &CPL25236GPIODlg::OnBnClickedButton1)
	ON_WM_DEVICECHANGE()
	ON_BN_CLICKED(IDC_CHK_P3_10_CE, &CPL25236GPIODlg::OnBnClickedChkP310Ce)
	ON_BN_CLICKED(IDC_CHK_P3_10_OE, &CPL25236GPIODlg::OnBnClickedChkP310Oe)
	ON_BN_CLICKED(IDC_BTN_Get_P3_10, &CPL25236GPIODlg::OnBnClickedBtnGetP310)
	ON_BN_CLICKED(IDC_BTN_Set_P3_10, &CPL25236GPIODlg::OnBnClickedBtnSetP310)
//	ON_EN_CHANGE(IDC_EDIT_SetValue_TX_LED5, &CPL25236GPIODlg::OnEnChangeEditSetvalueTxLed5)
ON_BN_CLICKED(IDC_Refresh_067B, &CPL25236GPIODlg::OnBnClickedRefresh067b)
ON_BN_CLICKED(IDC_RefreshFinal, &CPL25236GPIODlg::OnBnClickedRefreshfinal)
END_MESSAGE_MAP()


// CPL25236GPIODlg 訊息處理常式

BOOL CPL25236GPIODlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// 設定此對話方塊的圖示。當應用程式的主視窗不是對話方塊時，
	// 框架會自動從事此作業
	SetIcon(m_hIcon, TRUE);			// 設定大圖示
	SetIcon(m_hIcon, FALSE);		// 設定小圖示

	// TODO: 在此加入額外的初始設定

	CComboBox* cb = (CComboBox*)GetDlgItem(IDC_COMBO_PORT);
	cb->SetCurSel(2);
	cb = (CComboBox*)GetDlgItem(IDC_COMBO_SIZE);
	cb->SetCurSel(3);
	cb = (CComboBox*)GetDlgItem(IDC_COMBO_STOPBIT);
	cb->SetCurSel(0);
	cb = (CComboBox*)GetDlgItem(IDC_COMBO_PARITY);
	cb->SetCurSel(0);
	cb = (CComboBox*)GetDlgItem(IDC_COMBO_BAUDRATE);
	cb->SetCurSel(17);		// 115200 bps

	//OnDeviceChange();
	//OnBnClickedButRefresh(); //方法1，尋找所有Com Port
	//OnBnClickedRefresh067b(); //方法2，只尋找067B
	OnBnClickedRefreshfinal(); //方法3，尋找所有或指定Com Port

	return TRUE;  // 傳回 TRUE，除非您對控制項設定焦點
}

// 如果將最小化按鈕加入您的對話方塊，您需要下列的程式碼，
// 以便繪製圖示。對於使用文件/檢視模式的 MFC 應用程式，
// 框架會自動完成此作業。

void CPL25236GPIODlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 繪製的裝置內容

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 將圖示置中於用戶端矩形
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 描繪圖示
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// 當使用者拖曳最小化視窗時，
// 系統呼叫這個功能取得游標顯示。
HCURSOR CPL25236GPIODlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CPL25236GPIODlg::OnBnClickedBtnOpen()
{	// TODO: 在此加入控制項告知處理常式程式碼
	CString comStr, tmpStr;
	CComboBox* cb = (CComboBox*)GetDlgItem(IDC_COMBO_PORT);
	int nIndex = cb->GetCurSel();
	if (nIndex != CB_ERR) {
		cb->GetLBText(nIndex, comStr);

		//		if(m_bWindows2000)
		//			m_hCOM = ::CreateFile(comStr, GENERIC_READ | GENERIC_WRITE,
		//					0, NULL, OPEN_EXISTING, 0, NULL);
		//		else
		tmpStr = "\\\\.\\" + comStr;
		m_hCOM = ::CreateFile(tmpStr, GENERIC_READ | GENERIC_WRITE,
			0, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL);

		strResponse = "OPEN " + comStr + " port ";
		if (m_hCOM == INVALID_HANDLE_VALUE)
			strResponse += "FAILED.";
		else
			strResponse += "Successfully!";
		AddResponseString(strResponse);
	}
}

void CPL25236GPIODlg::AddResponseString(CString& str)
{
	CListBox* lb = (CListBox*)GetDlgItem(IDC_LIST_COMMAND_RESPONSE);
	int nIndex = lb->AddString(str);
	if (nIndex != LB_ERR || nIndex != LB_ERRSPACE)
		lb->SetCurSel(nIndex);
}

void CPL25236GPIODlg::OnBnClickedButClose()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	if (m_hCOM != INVALID_HANDLE_VALUE) {
		// CLR DTR/RTS
		::CloseHandle(m_hCOM);
		m_hCOM = INVALID_HANDLE_VALUE;
		strResponse = "Close COM port Successfully!";
		AddResponseString(strResponse);
	}
}


void CPL25236GPIODlg::OnBnClickedButtonClear()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	CListBox* output = (CListBox*)GetDlgItem(IDC_LIST_COMMAND_RESPONSE);
	output->ResetContent();
}


void CPL25236GPIODlg::OnBnClickedBtnSetstatus()
{
	// TODO: 在此加入控制項告知處理常式程式碼

	UpdateData();
	CString str;
	BOOL bSuccess;

	if (m_hCOM == INVALID_HANDLE_VALUE) {
		str = "Choose a COM port to set status.";
		AddResponseString(str);
		return;
	}

	bSuccess = ::GetCommState(m_hCOM, &m_DCB);
	if (!bSuccess) {
		str = "SET port status FAILED because cannot get status.";
		AddResponseString(str);
		return;
	}

	CComboBox* cb = (CComboBox*)GetDlgItem(IDC_COMBO_BAUDRATE);
	int nIndex = cb->GetCurSel();
	cb->GetLBText(nIndex, str);
	m_DCB.BaudRate = atol(str);

	cb = (CComboBox*)GetDlgItem(IDC_COMBO_SIZE);
	nIndex = cb->GetCurSel();
	cb->GetLBText(nIndex, str);
	m_DCB.ByteSize = atoi(str);

	cb = (CComboBox*)GetDlgItem(IDC_COMBO_STOPBIT);
	m_DCB.StopBits = cb->GetCurSel();

	cb = (CComboBox*)GetDlgItem(IDC_COMBO_PARITY);
	m_DCB.Parity = cb->GetCurSel();

	if ((m_DCB.ByteSize == 6 || m_DCB.ByteSize == 7 || m_DCB.ByteSize == 8) && (m_DCB.StopBits == 1)) {
		str = "ERROR - CANNOT set such combination.";
		AddResponseString(str);
		return;
	}

	if ((m_DCB.ByteSize == 5) && (m_DCB.StopBits == 2)) {
		str = "ERROR - CANNOT set such combination.";
		AddResponseString(str);
		return;
	}

	if (m_DCB.ByteSize == 5)
		m_DCB.StopBits++;

	bSuccess = ::SetCommState(m_hCOM, &m_DCB);
	if (!bSuccess) {
		str = "SET port status FAILED.";
		AddResponseString(str);
		return;
	}
	str = "SET port status Successfully!";
	AddResponseString(str);
	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedBtnGetstatus()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	CString str;
	const char* parityStr[] = { "None","Odd","Even","Mark","Space" };
	const char* stopBitsStr[] = { "1", "1.5", "2" };

	if (m_hCOM == INVALID_HANDLE_VALUE) {
		str = "Choose a COM port to get status.";
		AddResponseString(str);
		return;
	}

	BOOL bSuccess = ::GetCommState(m_hCOM, &m_DCB);
	if (!bSuccess) {
		str = "GET port status FAILED.";
		AddResponseString(str);
		return;
	}

	if (m_DCB.ByteSize == 5 && m_DCB.StopBits > 0)
		m_DCB.StopBits--;

	str.Format("BaudRate: %ld", m_DCB.BaudRate);
	AddResponseString(str);

	str.Format("Parity: %s", parityStr[m_DCB.Parity]);
	AddResponseString(str);

	str.Format("ByteSize: %d", m_DCB.ByteSize);
	AddResponseString(str);

	str.Format("StopBits: %s", stopBitsStr[m_DCB.StopBits]);
	AddResponseString(str);

	str = "------------------------------------------";
	AddResponseString(str);

}


void CPL25236GPIODlg::OnBnClickedChkTxLed0Ce()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 8;
	int  Channel = 0;
	BOOL enable;
	BOOL CHK = FALSE;
	int errCode;
	char str[MAX_PATH];

	if (mc_TX_LED0_CE.GetCheck()) {

		enable = 1;
		CHK = TRUE;

		mc_TX_LED0_OE.EnableWindow(1);
		mc_TX_LED0_OE.SetCheck(0);
		mc_TX_LED0_Get.EnableWindow(1);

	}
	else {

		enable = 0;

		mc_TX_LED0_OE.EnableWindow(0);
		mc_TX_LED0_OE.SetCheck(0);
		mc_TX_LED0_Get.EnableWindow(0);

	}

	mc_TX_LED0_Set.EnableWindow(0);
	mc_TX_LED0_edit.EnableWindow(0);

	//if (CHK)PL2523_6GPIO_CE_Config(m_hCOM, 0x0008, 0x0000, enable);

	if ((errCode = PL2523_6GPIO_CE_Config(m_hCOM, 0x0008, 0x0000, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_CE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_CE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);
	UpdateData(FALSE);
}

CString CPL25236GPIODlg::PL2523_CE_Printlog(int errorcode, BOOL enable, int PortNumber, int Channel)
{
	if (errorcode == 0) {
		if (enable) str_Response.Format("PL2523_P%d [ %d ] GPIO Control enable.", Channel, PortNumber);
		else	str_Response.Format("PL2523_P%d [ %d ] GPIO Control disable.", Channel, PortNumber);
	}
	else {
		str_Response.Format("PL2523_P%d [ %d ] GPIO Control Enable , FAILED!", Channel, PortNumber);
	}
	return str_Response;
}


void CPL25236GPIODlg::OnBnClickedChkTxLed0Oe()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 8;
	int  Channel = 0;
	BOOL enable;
	BOOL CHK = FALSE;
	int errCode;
	char str[MAX_PATH];

	if (mc_TX_LED0_OE.GetCheck()) {

		enable = 1;  // OE enable, GPIO:output mode
		CHK = TRUE;

		mc_TX_LED0_Get.EnableWindow(0);
		mc_TX_LED0_Set.EnableWindow(1);
		mc_TX_LED0_edit.EnableWindow(1);
	}
	else {

		enable = 0;  // OE disable,  GPIO:input mode

		mc_TX_LED0_Get.EnableWindow(1);
		mc_TX_LED0_Set.EnableWindow(0);
		mc_TX_LED0_edit.EnableWindow(0);
	}

	//if (CHK) PL2543_GPIO_OE_Config(m_hCOM, 0x0008, 0x0000, enable); 

	if ((errCode = PL2523_6GPIO_OE_Config(m_hCOM, 0x0008, 0x0000, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_OE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_OE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);
	UpdateData(FALSE);
}

CString CPL25236GPIODlg::PL2523_OE_Printlog(int errorcode, BOOL enable, int PortNumber, int Channel)
{
	if (errorcode == 0) {
		if (enable) str_Response.Format("PL2523_P%d [ %d ] GPIO Output enable.", Channel, PortNumber);
		else	str_Response.Format("PL2523_P%d [ %d ] GPIO Output disable.", Channel, PortNumber);
	}
	else {
		str_Response.Format("PL2523_P%d [ %d ] GPIO Output Enable , FAILED!", Channel, PortNumber);
	}
	return str_Response;
}


void CPL25236GPIODlg::OnBnClickedBtnGetTxLed0()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	int errCode;
	char str[MAX_PATH];
	//PL2543_GPIO_GET_Config(0x0008,0x0000);

	if ((errCode = PL2523_6GPIO_GET_Config(m_hCOM, 0x0008, 0x0000, &val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_GET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	else {
		str_Response = PL2523_Getval_Printlog(0x0008, 0x0000, val);
		AddResponseString(str_Response);
	}
	UpdateData(FALSE);
}

CString CPL25236GPIODlg::PL2523_Getval_Printlog(int PortNumber, int Channel, BYTE val)
{
	str_Response.Format("P%d [ %d ] Get val: %d ", Channel, PortNumber, val);

	return str_Response;
}


void CPL25236GPIODlg::OnBnClickedBtnSetTxLed0()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();

	int errCode;
	char str[MAX_PATH];

	//val = (BYTE)atoi(mv_TX_LED0_edit);  //文字轉int
	val = mv_TX_LED0_edit;
	/*str_Response.Format("val:0x%04d ", val);
	AddResponseString(str_Response);*/

	//PL2543_GPIO_SET_Config(0x0008, 0x0000,val);

	if ((errCode = PL2523_6GPIO_SET_Config(m_hCOM, 0x0008, 0x0000, val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_SET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	else {
		str_Response = PL2523_Setval_Printlog(0x0008, 0x0000, val);
		AddResponseString(str_Response);
	}
	UpdateData(FALSE);
}

CString CPL25236GPIODlg::PL2523_Setval_Printlog(int PortNumber, int Channel, BYTE val)
{
	str_Response.Format("P%d [ %d ] Set val: %d ", Channel, PortNumber, val);
	return str_Response;
}


void CPL25236GPIODlg::OnEnChangeEditSetvalueTxLed0()
{
	// TODO:  如果這是 RICHEDIT 控制項，控制項將不會
	// 傳送此告知，除非您覆寫 CDialogEx::OnInitDialog()
	// 函式和呼叫 CRichEditCtrl().SetEventMask()
	// 讓具有 ENM_CHANGE 旗標 ORed 加入遮罩。

	// TODO:  在此加入控制項告知處理常式程式碼
}


void CPL25236GPIODlg::OnBnClickedChkRxLed0Ce()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 9;
	int  Channel = 0;
	BOOL enable;
	BOOL CHK = FALSE;
	int errCode;
	char str[MAX_PATH];

	if (mc_RX_LED0_CE.GetCheck()) {

		enable = 1;
		CHK = TRUE;

		mc_RX_LED0_OE.EnableWindow(1);
		mc_RX_LED0_OE.SetCheck(0);
		mc_RX_LED0_Get.EnableWindow(1);

	}
	else {

		enable = 0;

		mc_RX_LED0_OE.EnableWindow(0);
		mc_RX_LED0_OE.SetCheck(0);
		mc_RX_LED0_Get.EnableWindow(0);

	}

	mc_RX_LED0_Set.EnableWindow(0);
	mc_RX_LED0_edit.EnableWindow(0);

	//if (CHK)PL2523_6GPIO_CE_Config(m_hCOM, 0x0009, 0x0000, enable);

	if ((errCode = PL2523_6GPIO_CE_Config(m_hCOM, 0x0009, 0x0000, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_CE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_CE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);

	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedChkRxLed0Oe()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 9;
	int  Channel = 0;
	BOOL enable;
	BOOL CHK = FALSE;
	int errCode;
	char str[MAX_PATH];

	if (mc_RX_LED0_OE.GetCheck()) {

		enable = 1;  // OE enable, GPIO:output mode
		CHK = TRUE;

		mc_RX_LED0_Get.EnableWindow(0);
		mc_RX_LED0_Set.EnableWindow(1);
		mc_RX_LED0_edit.EnableWindow(1);
	}
	else {

		enable = 0;  // OE disable,  GPIO:input mode

		mc_RX_LED0_Get.EnableWindow(1);
		mc_RX_LED0_Set.EnableWindow(0);
		mc_RX_LED0_edit.EnableWindow(0);
	}

	//if (CHK) PL2523_6GPIO_OE_Config(m_hCOM, 0x0009, 0x0000, enable); 

	if ((errCode = PL2523_6GPIO_OE_Config(m_hCOM, 0x0009, 0x0000, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_OE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_OE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);
	UpdateData(FALSE);
}



void CPL25236GPIODlg::OnBnClickedBtnGetRxLed0()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	int errCode;
	char str[MAX_PATH];

	//PL2543_GPIO_GET_Config(0x0009,0x0000);
	if ((errCode = PL2543_11GPIO_GET_Config(m_hCOM, 0x0009, 0x0000, &val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2543_GPIO_GET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	else {
		str_Response = PL2523_Getval_Printlog(0x0009, 0x0000, val);
		AddResponseString(str_Response);
	}
	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedBtnSetRxLed0()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	int errCode;
	char str[MAX_PATH];


	//val = (BYTE)atoi(mv_RX_LED0_edit);  //文字轉int
	val = mv_Rx_LED0_edit;
	/*str_Response.Format("val: 0x%04d ", val);
	AddResponseString(str_Response);*/

	//PL2543_GPIO_SET_Config(0x0009, 0x0000, val);

	if ((errCode = PL2523_6GPIO_SET_Config(m_hCOM, 0x0009, 0x0000, val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_SET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}

	else {
		str_Response = PL2523_Setval_Printlog(0x0009, 0x0000, val);
		AddResponseString(str_Response);
	}

	UpdateData(FALSE);

}


void CPL25236GPIODlg::OnBnClickedChkTxLed1Ce()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 8;
	int  Channel = 1;
	BOOL enable;
	BOOL CHK = FALSE;
	int errCode;
	char str[MAX_PATH];

	if (mc_TX_LED1_CE.GetCheck()) {

		enable = 1;
		CHK = TRUE;

		mc_TX_LED1_OE.EnableWindow(1);
		mc_TX_LED1_OE.SetCheck(0);
		mc_TX_LED1_Get.EnableWindow(1);

	}
	else {

		enable = 0;

		mc_TX_LED1_OE.EnableWindow(0);
		mc_TX_LED1_OE.SetCheck(0);
		mc_TX_LED1_Get.EnableWindow(0);

	}

	mc_TX_LED1_Set.EnableWindow(0);
	mc_TX_LED1_edit.EnableWindow(0);

	//if (CHK) PL2523_6GPIO_CE_Config(m_hCOM, 0x0008, 0x0001, enable);

	if ((errCode = PL2523_6GPIO_CE_Config(m_hCOM, 0x0008, 0x0001, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_CE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_CE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);

	UpdateData(FALSE);

}


void CPL25236GPIODlg::OnBnClickedBtnGetTxLed1()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	int errCode;
	char str[MAX_PATH];

	//PL2523_GPIO_GET_Config(0x0008, 0x0001);

	if ((errCode = PL2523_6GPIO_GET_Config(m_hCOM, 0x0008, 0x0001, &val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_GET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	else {
		str_Response = PL2523_Getval_Printlog(0x0008, 0x0001, val);
		AddResponseString(str_Response);
	}

	UpdateData(FALSE);
}

void CPL25236GPIODlg::OnBnClickedBtnSetTxLed1()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	int errCode;
	char str[MAX_PATH];

	val = (BYTE)atoi(mv_TX_LED1_edit);  //文字轉int
	/*str_Response.Format("PL2523_val:%d", val);
	AddResponseString(str_Response);*/
	//val = mv_TX_LED1_edit;

	//PL2523_GPIO_SET_Config(0x0008,0x0001,val);
	if ((errCode = PL2523_6GPIO_SET_Config(m_hCOM, 0x0008, 0x0001, val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_SET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}

	else {
		str_Response = PL2523_Setval_Printlog(0x0008, 0x0001, val);
		AddResponseString(str_Response);
	}
	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedChkTxLed1Oe()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 8;
	int  Channel = 1;
	BOOL enable;
	BOOL CHK = FALSE;
	int errCode;
	char str[MAX_PATH];

	if (mc_TX_LED1_OE.GetCheck()) {

		enable = 1;  // OE enable, GPIO:output mode
		CHK = TRUE;

		mc_TX_LED1_Get.EnableWindow(0);
		mc_TX_LED1_Set.EnableWindow(1);
		mc_TX_LED1_edit.EnableWindow(1);
	}
	else {

		enable = 0;  // OE disable,  GPIO:input mode

		mc_TX_LED1_Get.EnableWindow(1);
		mc_TX_LED1_Set.EnableWindow(0);
		mc_TX_LED1_edit.EnableWindow(0);
	}

	//if (CHK) { PL2523_GPIO_OE_Config(m_hCOM, 0x0008, 0x0001, enable); }

	if ((errCode = PL2523_6GPIO_OE_Config(m_hCOM, 0x0008, 0x0001, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_OE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_OE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);
	UpdateData(FALSE);

}


void CPL25236GPIODlg::OnBnClickedChkTxLed1Ce2()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 9;
	int  Channel = 1;
	BOOL  enable;
	BOOL CHK = FALSE;
	int errCode;
	char str[MAX_PATH];


	if (mc_RX_LED1_CE.GetCheck()) {

		enable = 1;  // CE enable, GPIO:input mode
		CHK = TRUE;

		mc_RX_LED1_OE.EnableWindow(1);
		mc_RX_LED1_OE.SetCheck(0);
		mc_RX_LED1_Get.EnableWindow(1);

	}
	else {

		enable = 0;  // CE disable, 回復原狀

		mc_RX_LED1_OE.EnableWindow(0);
		mc_RX_LED1_OE.SetCheck(0);
		mc_RX_LED1_Get.EnableWindow(0);

	}

	mc_RX_LED1_Set.EnableWindow(0);
	mc_RX_LED1_edit.EnableWindow(0);

	//if (CHK) PL2543_GPIO_CE_Config(m_hCOM, 0x0009, 0x0001, enable);

	if ((errCode = PL2523_6GPIO_CE_Config(m_hCOM, 0x0009, 0x0001, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_CE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_CE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);

	UpdateData(FALSE);
}



void CPL25236GPIODlg::OnBnClickedChkTxLed1Oe2()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 9;
	int  Channel = 1;
	BOOL enable;
	BOOL CHK = FALSE;
	int errCode;
	char str[MAX_PATH];

	if (mc_RX_LED1_OE.GetCheck()) {

		enable = 1;  // OE enable, GPIO:output mode
		CHK = 1;

		mc_RX_LED1_Get.EnableWindow(0);
		mc_RX_LED1_Set.EnableWindow(1);
		mc_RX_LED1_edit.EnableWindow(1);
	}
	else {

		enable = 0;  // OE disable,  GPIO:input mode

		mc_RX_LED1_Get.EnableWindow(1);
		mc_RX_LED1_Set.EnableWindow(0);
		mc_RX_LED1_edit.EnableWindow(0);
	}

	//if (CHK) { PL2543_GPIO_OE_Config(m_hCOM, 0x0009, 0x0001, enable); }

	if ((errCode = PL2523_6GPIO_OE_Config(m_hCOM, 0x0009, 0x0001, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_OE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_OE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);
	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedBtnGetTxLed2()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();

	int errCode;
	char str[MAX_PATH];
	//PL2543_GPIO_GET_Config(0x0009, 0x0001);

	if ((errCode = PL2523_6GPIO_GET_Config(m_hCOM, 0x0009, 0x0001, &val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_GET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	else {
		str_Response = PL2523_Getval_Printlog(0x0009, 0x0001, val);
		AddResponseString(str_Response);
	}

	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedBtnSetTxLed2()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	int errCode;
	char str[MAX_PATH];

	//val = (BYTE)atoi(mv_TX_LED0_edit);  //文字轉int
	val = mv_RX_LED1_edit;

	//PL2523_GPIO_SET_Config(0x0009,0x0001,val);

	if ((errCode = PL2523_6GPIO_SET_Config(m_hCOM, 0x0009, 0x0001, val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_SET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}

	else {
		str_Response = PL2523_Setval_Printlog(0x0009, 0x0001, val);
		AddResponseString(str_Response);
	}

	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedChkTxLed1Ce4()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 7;
	int  Channel = 2;
	BOOL enable;
	BOOL CHK = 0;
	int errCode;
	char str[MAX_PATH];

	if (mc_P2_7_CE.GetCheck()) {

		enable = 1;  // CE enable, GPIO:input mode
		CHK = 1;

		mc_P2_7_OE.EnableWindow(1);
		mc_P2_7_OE.SetCheck(0);
		mc_P2_7_Get.EnableWindow(1);

	}
	else {

		enable = 0;  // CE disable, 回復原狀

		mc_P2_7_OE.EnableWindow(0);
		mc_P2_7_OE.SetCheck(0);
		mc_P2_7_Get.EnableWindow(0);

	}

	mc_P2_7_Set.EnableWindow(0);
	mc_P2_7_edit.EnableWindow(0);

	//if (CHK)  PL2523_GPIO_CE_Config(m_hCOM, 0x0007, 0x0002, enable); 

	if ((errCode = PL2523_6GPIO_CE_Config(m_hCOM, 0x0007, 0x0002, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_CE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_CE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);

	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedChkTxLed1Oe4()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 7;
	int  Channel = 2;
	BOOL enable;
	BOOL CHK = 0;
	int errCode;
	char str[MAX_PATH];

	if (mc_P2_7_OE.GetCheck()) {

		enable = 1;  // OE enable, GPIO:output mode
		CHK = 1;

		mc_P2_7_Get.EnableWindow(0);
		mc_P2_7_Set.EnableWindow(1);
		mc_P2_7_edit.EnableWindow(1);
	}
	else {

		enable = 0;  // OE disable, GPIO:input mode

		mc_P2_7_Get.EnableWindow(1);
		mc_P2_7_Set.EnableWindow(0);
		mc_P2_7_edit.EnableWindow(0);
	}

	//if (CHK) PL2523_6GPIO_OE_Config(m_hCOM, 0x0007, 0x0002, enable); 

	if ((errCode = PL2523_6GPIO_OE_Config(m_hCOM, 0x0007, 0x0002, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_OE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_OE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);
	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedBtnGetTxLed4()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	int errCode;
	char str[MAX_PATH];

	//PL2523_6GPIO_GET_Config(0x0007, 0x0002);

	if ((errCode = PL2523_6GPIO_GET_Config(m_hCOM, 0x0007, 0x0002, &val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_GET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}

	else {
		str_Response = PL2523_Getval_Printlog(0x0007, 0x0002, val);
		AddResponseString(str_Response);
	}

	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedBtnSetTxLed4()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	int errCode;
	char str[MAX_PATH];

	//val = (BYTE)atoi(mv_P2_7_edit);  //文字轉int
	val = mv_P2_7_edit;

	//PL2523_6GPIO_SET_Config(0x0007, 0x002, val);
	if ((errCode = PL2523_6GPIO_SET_Config(m_hCOM, 0x0007, 0x0002, val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_SET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	else {
		str_Response = PL2523_Setval_Printlog(0x0007, 0x0002, val);
		AddResponseString(str_Response);
	}
	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedChkTxLed1Ce5()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 9;
	int  Channel = 2;
	BOOL enable;
	BOOL CHK = 0;
	int errCode;
	char str[MAX_PATH];

	if (mc_P2_9_CE.GetCheck()) {

		enable = 1;  // CE enable, GPIO:input mode
		CHK = 1;

		mc_P2_9_OE.EnableWindow(1);
		mc_P2_9_OE.SetCheck(0);
		mc_P2_9_Get.EnableWindow(1);

	}
	else {

		enable = 0;  // CE disable, 回復原狀

		mc_P2_9_OE.EnableWindow(0);
		mc_P2_9_OE.SetCheck(0);
		mc_P2_9_Get.EnableWindow(0);

	}

	mc_P2_9_Set.EnableWindow(0);
	mc_P2_9_edit.EnableWindow(0);

	//if (CHK)  PL2523_GPIO_CE_Config(m_hCOM, 0x0009, 0x0002, enable); 

	if ((errCode = PL2523_6GPIO_CE_Config(m_hCOM, 0x0009, 0x0002, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_CE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_CE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);

	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedChkTxLed1Oe5()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 9;
	int  Channel = 2;
	BOOL enable;
	BOOL CHK = 0;
	int errCode;
	char str[MAX_PATH];

	if (mc_P2_9_OE.GetCheck()) {

		enable = 1;  // OE enable, GPIO:output mode
		CHK = 1;

		mc_P2_9_Get.EnableWindow(0);
		mc_P2_9_Set.EnableWindow(1);
		mc_P2_9_edit.EnableWindow(1);
	}
	else {

		enable = 0;  // OE disable, GPIO:input mode

		mc_P2_9_Get.EnableWindow(1);
		mc_P2_9_Set.EnableWindow(0);
		mc_P2_9_edit.EnableWindow(0);
	}

	//if (CHK) PL2523_6GPIO_OE_Config(m_hCOM, 0x0009, 0x0002, enable); 

	if ((errCode = PL2523_6GPIO_OE_Config(m_hCOM, 0x0009, 0x0002, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_OE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_OE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);
	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedBtnGetTxLed5()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	int errCode;
	char str[MAX_PATH];

	//PL2523_6GPIO_GET_Config(0x0009, 0x0002);

	if ((errCode = PL2523_6GPIO_GET_Config(m_hCOM, 0x0009, 0x0002, &val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_GET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}

	else {
		str_Response = PL2523_Getval_Printlog(0x0009, 0x0002, val);
		AddResponseString(str_Response);
	}

	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedBtnSetTxLed5()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	int errCode;
	char str[MAX_PATH];

	//val = (BYTE)atoi(mv_P2_9_edit);  //文字轉int
	val = mv_P2_9_edit;

	//PL2523_6GPIO_SET_Config(0x0009, 0x002, val);
	if ((errCode = PL2523_6GPIO_SET_Config(m_hCOM, 0x0009, 0x0002, val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_SET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	else {
		str_Response = PL2523_Setval_Printlog(0x0009, 0x0002, val);
		AddResponseString(str_Response);
	}
	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnCbnSelchangeComboPort()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UINT nIndex = m_cboDevice.GetCurSel();
}

void CPL25236GPIODlg::OnBnClickedButRefresh() //方法1，尋找所有Com Port
{
	// TODO: 在此加入控制項告知處理常式程式碼
	CString strCOMName, strmsg;
	int nSel;
	int nIndex, DeviceCount;
	CString ComNamebuf[20];
	GUID deviceGuid = GUID_DEVINTERFACE_COMPORT;	//GUID_DEVINTERFACE_SERENUM_BUS_ENUMERATOR;

	strmsg.Format("Refresh方法1");
	if (PrintLog) AddResponseString(strmsg);

	m_cboDevice.ResetContent();
	m_cboDevice.AddString(_T(" "));
	EnumDevice(deviceGuid, m_cboDevice);
	if (m_cboDevice.GetCount() > 0) {
		m_cboDevice.SetCurSel(1); //位置:1
	}
	
	strmsg.Format("GetCount:%d", m_cboDevice.GetCount());
	//AddResponseString(strmsg);

	DeviceCount = m_cboDevice.GetCount();

	for (int i = 1; i < DeviceCount; i++) {
		m_cboDevice.GetLBText(i, strCOMName);
		//AddResponseString(strCOMName);
		nIndex = strCOMName.FindOneOf("("); //抓到(

		strmsg.Format("Index:%d", nIndex); //抓到nlndex=11
		//AddResponseString(strmsg); //印出nlndex=11

		strmsg = strCOMName.Mid(nIndex + 1);
		//AddResponseString(strmsg);  //COM1

		strmsg = strmsg.TrimRight(")");
		//AddResponseString(strmsg);  // 1
		
		ComNamebuf[i - 1] = strmsg;	
	}
	
	m_cboDevice.ResetContent(); //清除下拉所有選項

	for (int i = 0; i < DeviceCount-1; i++) {
		strmsg.Format("Buf[:%d]:%s", i, ComNamebuf[i]);
		//AddResponseString(strmsg);
		m_cboDevice.AddString(ComNamebuf[i]); //add buf, 看找到幾個一個一個加下拉選項
	}
	
	m_cboDevice.SetCurSel(0); //把位置設定在第一個

}

UINT CPL25236GPIODlg::EnumDevice(GUID& DeviceGuid, CComboBox& cboDevice) //方法1，尋找所有Com Port
{
	HDEVINFO hDeviceInfo;
	m_unDeviceCount = 0;
	hDeviceInfo = SetupDiGetClassDevs(&DeviceGuid, NULL, NULL, (DIGCF_PRESENT | DIGCF_DEVICEINTERFACE));
	if (hDeviceInfo == INVALID_HANDLE_VALUE)
	{
		// Insert error handling here.
		OutputDebugString(_T("SetupDiGetClassDevs Invalid Handle"));
		return 1;
	}

	PSP_DEVICE_INTERFACE_DETAIL_DATA deviceDetailData;

	CString strMsg;
	int nDeviceIndex = 0;
	SP_DEVINFO_DATA devInfoData;
	ZeroMemory(&devInfoData, sizeof(devInfoData));
	devInfoData.cbSize = sizeof(devInfoData);
	while (SetupDiEnumDeviceInfo(hDeviceInfo,            // Our device tree
		nDeviceIndex++,            // The member to look for
		&devInfoData))
	{
		BOOL bReturn = FALSE;
		DWORD dwRegDataType;
		DWORD dwRequireSize = MAX_PATH;
		//deviceDetailData = (PSP_DEVICE_INTERFACE_DETAIL_DATA)GlobalAlloc(GPTR, dwRequireSize);
		//deviceDetailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
		//SetupDiGetDeviceInterfaceDetail(hDeviceInfo,
		//								&deviceInfoData,
		//								deviceDetailData,
		//								dwRequireSize,
		//								&dwRequireSize,
		//								NULL);
		//GlobalFree(deviceDetailData);

		//Step1 : Get SPDRP_HARDWAREID
		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_HARDWAREID,
			&m_ComPortDeviceArray[m_unDeviceCount].wchHardwareId[0]);

		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_DRIVER,
			&m_ComPortDeviceArray[m_unDeviceCount].wchDriver[0]);

		//bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_ADDRESS, 
		//							&m_ComPortDeviceArray[m_unDeviceCount].wchDeviceAddress[0]);

		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_PHYSICAL_DEVICE_OBJECT_NAME,
			&m_ComPortDeviceArray[m_unDeviceCount].wchPhysicalDeviceObjectName[0]);

		//Step2 : Get SPDRP_FRIENDLYNAME 
		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_FRIENDLYNAME,
			&m_ComPortDeviceArray[m_unDeviceCount].wchFriendlyName[0]);
		strMsg.Format(_T("%s"), m_ComPortDeviceArray[m_unDeviceCount].wchFriendlyName);
		//cboDevice.AddString(m_ComPortDeviceArray[m_unDeviceCount].wchFriendlyName);
		cboDevice.AddString(strMsg);


		//Step3 : Get SPDRP_LOCATION_PATHS
		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_LOCATION_PATHS,
			&m_ComPortDeviceArray[m_unDeviceCount].wchLocationPath[0]);

		//Step4 : Get SPDRP_LOCATION_INFORMATION
		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_LOCATION_INFORMATION,
			&m_ComPortDeviceArray[m_unDeviceCount].wchLocationInfo[0]);

		m_unDeviceCount++;
	}
	SetupDiDestroyDeviceInfoList(hDeviceInfo);
	return 0;	//Success
}

void CPL25236GPIODlg::Refresh_067B() //方法2，只尋找067B
{
	// TODO: 在此加入控制項告知處理常式程式碼
	CString strCOMName, strmsg;
	int nSel;
	int nIndex, DeviceCount, k;
	CString ComNamebuf[20];
	CString findstr = "067B";
	GUID deviceGuid[20];
	//	GUID deviceGuid = GUID_DEVINTERFACE_COMPORT;
	deviceGuid[0] = GUID_DEVINTERFACE_COMPORT; //尋找Com Port	
	//deviceGuid[1] = GUID_DEVINTERFACE_HID; //尋找HID
	//deviceGuid[2] = GUID_DEVINTERFACE_CDROM; //尋找CD-ROM

	/*For(int i = 0; i < sizeof(deviceGuid); i++) { //For 尋找HID/CD-ROM
		m_cboDevice.ResetContent(); //清空下拉式
		m_cboDevice.AddString(_T(" ")); //新增空白, 因應筆電...等系列沒有port
		EnumDevice_067B(deviceGuid[i], m_cboDevice); 

	}*/

	strmsg.Format("Refresh_067B ");
	if (PrintLog) AddResponseString(strmsg);

	m_cboDevice.ResetContent();//清空下拉式
	m_cboDevice.AddString(_T(" ")); //新增空白, 因應筆電...等系列沒有port
	EnumDevice_067B(deviceGuid[0], m_cboDevice);
	

	DeviceCount = m_cboDevice.GetCount();
	strmsg.Format("Enum Done! ");
	if (PrintLog) AddResponseString(strmsg);

	for (int i = 1; i < DeviceCount; i++) { //第一個是空白, 從1開始算

		m_cboDevice.GetLBText(i, strCOMName);
		if (PrintLog) AddResponseString(strCOMName);
	}

	if (m_cboDevice.GetCount() > 0) {
		m_cboDevice.SetCurSel(1); //位置:1
	}

	strmsg.Format(" ");
	if (PrintLog) AddResponseString(strmsg);
	strmsg.Format("GetCount:%d", m_cboDevice.GetCount());
	if (PrintLog) AddResponseString(strmsg);


	DeviceCount = m_cboDevice.GetCount();

	for (int i = 1; i < DeviceCount; i++) { //第一個是空白, 從1開始算

		m_cboDevice.GetLBText(i, strCOMName);
		//AddResponseString(strCOMName);
		nIndex = strCOMName.FindOneOf("("); //抓到(

		strmsg.Format("Index:%d", nIndex); //抓到nlndex=
		//AddResponseString(strmsg); //印出nlndex=

		strmsg = strCOMName.Mid(nIndex + 1);
		//AddResponseString(strmsg);  // (COM1)有左括弧

		//strmsg = strCOMName.Mid(nIndex);
		//AddResponseString(strmsg);  // COM1)沒有左括弧

		strmsg = strmsg.TrimRight(")");
		if (PrintLog) AddResponseString(strmsg);  // 印出COM1

		ComNamebuf[i] = strmsg;
		//AddResponseString(strmsg); //抓到com port

	}

	/*for (int i = 0; i < DeviceCount; i++) {
		k =  strCOMName.Find(findstr);
		strmsg.Format(" k Index:%d", k);
		AddResponseString(strmsg);  //找出k<1 或 k>1
		if (k > 1) bIsPL2303[i] = true;
		else bIsPL2303[i] = false;}
		*/


	m_cboDevice.ResetContent(); //清除下拉所有選項



	for (int i = 1; i < DeviceCount; i++)
	{
		//strmsg.Format(" ");
		//AddResponseString(strmsg);
		//strmsg.Format("Buf[:%d]:%s", i, ComNamebuf[i]);//抓到Buf 幾個, 幾個com port
		//AddResponseString(strmsg); 

		//strmsg.Format(" bIsPL2303[%d]: true", i);
		//AddResponseString(strmsg);
		m_cboDevice.AddString(ComNamebuf[i]); //add buf, 看找到幾個一個一個加下拉選項
	}

	m_cboDevice.SetCurSel(0); //把位置設定在第一個

}

UINT CPL25236GPIODlg::EnumDevice_067B(GUID& DeviceGuid, CComboBox& cboDevice) //方法2，只尋找067B
{
	HDEVINFO hDeviceInfo;
	m_unDeviceCount = 0;
	hDeviceInfo = SetupDiGetClassDevs(&DeviceGuid, NULL, NULL, (DIGCF_PRESENT | DIGCF_DEVICEINTERFACE));
	if (hDeviceInfo == INVALID_HANDLE_VALUE)
	{
		// Insert error handling here.
		OutputDebugString(_T("SetupDiGetClassDevs Invalid Handle"));
		return 1;
	}

	PSP_DEVICE_INTERFACE_DETAIL_DATA deviceDetailData;

	CString strMsg, strCOMName;
	CString strmsg;
	int nIndex;
	int nDeviceIndex = 0;
	SP_DEVINFO_DATA devInfoData;
	ZeroMemory(&devInfoData, sizeof(devInfoData));
	devInfoData.cbSize = sizeof(devInfoData);
	while (SetupDiEnumDeviceInfo(hDeviceInfo,            // Our device tree
		nDeviceIndex++,            // The member to look for
		&devInfoData))
	{
		BOOL bReturn = FALSE;
		DWORD dwRegDataType;
		DWORD dwRequireSize = MAX_PATH;
		//deviceDetailData = (PSP_DEVICE_INTERFACE_DETAIL_DATA)GlobalAlloc(GPTR, dwRequireSize);
		//deviceDetailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
		//SetupDiGetDeviceInterfaceDetail(hDeviceInfo,
		//								&deviceInfoData,
		//								deviceDetailData,
		//								dwRequireSize,
		//								&dwRequireSize,
		//								NULL);
		//GlobalFree(deviceDetailData);
		strmsg.Format(" ");
		if (PrintLog) AddResponseString(strmsg);
		//if(PrintLog) AddResponseString(strmsg);

		strmsg.Format("m_unDeviceCount-A:%d ", m_unDeviceCount);
		if (PrintLog) AddResponseString(strmsg);

		//Step1 : Get SPDRP_HARDWAREID
		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_HARDWAREID,
			&m_ComPortDeviceArray[m_unDeviceCount].wchHardwareId[0]);
		strmsg.Format("HARDWAREID:%s ", &m_ComPortDeviceArray[m_unDeviceCount].wchHardwareId[0]);
		//找Hardware ID → USB\VID_067B&PID_2543&REV_4302&MI_00
		if (PrintLog) AddResponseString(strmsg);
		CString findstr1 = "VID_067B&PID_2543";
		int k = strmsg.Find(findstr1);

//#if defined(FindPL2303)

		if (k < 0) {
			strmsg.Format(" 不是2303, 跳離迴圈");
			if (PrintLog) AddResponseString(strmsg);
			continue;

		}
//#endif



		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_DRIVER,
			&m_ComPortDeviceArray[m_unDeviceCount].wchDriver[0]);
		strmsg.Format("DRIVER:%s ", &m_ComPortDeviceArray[m_unDeviceCount].wchDriver[0]);
		if (PrintLog) AddResponseString(strmsg);

		//bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_ADDRESS, 
		//							&m_ComPortDeviceArray[m_unDeviceCount].wchDeviceAddress[0]);

		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_PHYSICAL_DEVICE_OBJECT_NAME,
			&m_ComPortDeviceArray[m_unDeviceCount].wchPhysicalDeviceObjectName[0]);
		strmsg.Format("DEVICE_OBJECT_NAME:%s ", &m_ComPortDeviceArray[m_unDeviceCount].wchPhysicalDeviceObjectName[0]);
		if (PrintLog) AddResponseString(strmsg);

		//Step2 : Get SPDRP_FRIENDLYNAME 
		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_FRIENDLYNAME,
			&m_ComPortDeviceArray[m_unDeviceCount].wchFriendlyName[0]);
		strmsg.Format("FRIENDLYNAME:%s ", &m_ComPortDeviceArray[m_unDeviceCount].wchFriendlyName[0]);
		if (PrintLog) AddResponseString(strmsg);
		strMsg.Format(_T("%s"), m_ComPortDeviceArray[m_unDeviceCount].wchFriendlyName);
		//cboDevice.AddString(m_ComPortDeviceArray[m_unDeviceCount].wchFriendlyName);
		cboDevice.AddString(strMsg);


		//Step3 : Get SPDRP_LOCATION_PATHS
		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_LOCATION_PATHS,
			&m_ComPortDeviceArray[m_unDeviceCount].wchLocationPath[0]);
		strmsg.Format("LOCATION_PATHS:%s ", &m_ComPortDeviceArray[m_unDeviceCount].wchLocationPath[0]);
		if (PrintLog) AddResponseString(strmsg);

		//Step4 : Get SPDRP_LOCATION_INFORMATION
		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_LOCATION_INFORMATION,
			&m_ComPortDeviceArray[m_unDeviceCount].wchLocationInfo[0]);
		strmsg.Format("LOCATION_INFORMATION:%s ", &m_ComPortDeviceArray[m_unDeviceCount].wchLocationInfo[0]);
		if (PrintLog) AddResponseString(strmsg);

		m_unDeviceCount++;
		strmsg.Format("m_unDeviceCount-B:%d ", m_unDeviceCount);
		if (PrintLog) AddResponseString(strmsg);
	}
	SetupDiDestroyDeviceInfoList(hDeviceInfo);
	return 0;	//Success
}

void CPL25236GPIODlg::Refresh_Final() //方法3，可全部尋找或指定067B...
{
	// TODO: 在此加入控制項告知處理常式程式碼
	CString strCOMName, strmsg;
	int nSel;
	int nIndex, DeviceCount, k;
	CString ComNamebuf[20];
	GUID deviceGuid[20];
	CString findstr1 = "VID_067B&PID_2543";  // 只找2543,len:17
	//CString findstr1 = "PID_2543";  // 只找2543,len:8
	//CString findstr1 = "VID_067B&PID_2303";  // 只找2303,len:17
	//CString findstr1 = "VID_067B&PID_23A3";  // 只找23A3,len:17
	//CString findstr1 = "";  // 找全部Com Port,len:0

	strmsg.Format("Refresh Final ");
	if (PrintLog) AddResponseString(strmsg);

	//	GUID deviceGuid = GUID_DEVINTERFACE_COMPORT;
	deviceGuid[0] = GUID_DEVINTERFACE_COMPORT; //尋找Com Port	
	//deviceGuid[1] = GUID_DEVINTERFACE_HID; //尋找HID
	//deviceGuid[2] = GUID_DEVINTERFACE_CDROM; //尋找CD-ROM

	/*For(int i = 0; i < sizeof(deviceGuid); i++) { //For 尋找HID/CD-ROM
		m_cboDevice.ResetContent(); //清空下拉式
		m_cboDevice.AddString(_T(" ")); //新增空白, 因應筆電...等系列沒有port
		EnumDevice_Final(deviceGuid[i], m_cboDevice);

	}*/

	m_cboDevice.ResetContent();//清空下拉式
	m_cboDevice.AddString(_T(" ")); //新增空白, 因應筆電...等系列沒有port
	//找Hardware ID → USB\VID_067B&PID_2543&REV_4302&MI_00
	EnumDevice_Final(deviceGuid[0], m_cboDevice, findstr1); //尋找Hardware ID
	
	DeviceCount = m_cboDevice.GetCount();
	
	strmsg.Format("Enum Done! ");
	if (PrintLog) AddResponseString(strmsg);

	for (int i = 1; i < DeviceCount; i++) { //第一個是空白, 從1開始算

		m_cboDevice.GetLBText(i, strCOMName);
		if (PrintLog) AddResponseString(strCOMName);
	}

	if (m_cboDevice.GetCount() > 0) {
		m_cboDevice.SetCurSel(1); //位置:1
	}

	strmsg.Format(" ");
	if (PrintLog) AddResponseString(strmsg);
	strmsg.Format("GetCount:%d", m_cboDevice.GetCount());
	if (PrintLog) AddResponseString(strmsg);


	DeviceCount = m_cboDevice.GetCount();

	for (int i = 1; i < DeviceCount; i++) { //第一個是空白, 從1開始算

		m_cboDevice.GetLBText(i, strCOMName);
		//AddResponseString(strCOMName);
		nIndex = strCOMName.FindOneOf("("); //抓到(

		strmsg.Format("Index:%d", nIndex); //抓到nlndex=
		//AddResponseString(strmsg); //印出nlndex=

		strmsg = strCOMName.Mid(nIndex + 1);
		//AddResponseString(strmsg);  // (COM1)有左括弧

		//strmsg = strCOMName.Mid(nIndex);
		//AddResponseString(strmsg);  // COM1)沒有左括弧

		strmsg = strmsg.TrimRight(")");
		if (PrintLog) AddResponseString(strmsg);  // 印出COM1

		ComNamebuf[i] = strmsg;
		//AddResponseString(strmsg); //抓到com port

	}

	/*for (int i = 0; i < DeviceCount; i++) {
		k =  strCOMName.Find(findstr);
		strmsg.Format(" k Index:%d", k);
		AddResponseString(strmsg);  //找出k<1 或 k>1
		if (k > 1) bIsPL2303[i] = true;
		else bIsPL2303[i] = false;}
		*/


	m_cboDevice.ResetContent(); //清除下拉所有選項



	for (int i = 1; i < DeviceCount; i++)
	{
		//strmsg.Format(" ");
		//AddResponseString(strmsg);
		//strmsg.Format("Buf[:%d]:%s", i, ComNamebuf[i]);//抓到Buf 幾個, 幾個com port
		//AddResponseString(strmsg); 

		//strmsg.Format(" bIsPL2303[%d]: true", i);
		//AddResponseString(strmsg);
		m_cboDevice.AddString(ComNamebuf[i]); //add buf, 看找到幾個一個一個加下拉選項
	}

	m_cboDevice.SetCurSel(0); //把位置設定在第一個

}

UINT CPL25236GPIODlg::EnumDevice_Final(GUID& DeviceGuid, CComboBox& cboDevice,CString srtVIDPID) ////方法3，可全部尋找或指定067B...
{
	HDEVINFO hDeviceInfo;
	m_unDeviceCount = 0;
	hDeviceInfo = SetupDiGetClassDevs(&DeviceGuid, NULL, NULL, (DIGCF_PRESENT | DIGCF_DEVICEINTERFACE));
	if (hDeviceInfo == INVALID_HANDLE_VALUE)
	{
		// Insert error handling here.
		OutputDebugString(_T("SetupDiGetClassDevs Invalid Handle"));
		return 1;
	}

	PSP_DEVICE_INTERFACE_DETAIL_DATA deviceDetailData;

	CString strMsg, strCOMName;
	CString strmsg;
	int nIndex;
	int nDeviceIndex = 0;
	SP_DEVINFO_DATA devInfoData;
	ZeroMemory(&devInfoData, sizeof(devInfoData));
	devInfoData.cbSize = sizeof(devInfoData);
	while (SetupDiEnumDeviceInfo(hDeviceInfo,            // Our device tree
		nDeviceIndex++,            // The member to look for
		&devInfoData))
	{
		BOOL bReturn = FALSE;
		DWORD dwRegDataType;
		DWORD dwRequireSize = MAX_PATH;
		//deviceDetailData = (PSP_DEVICE_INTERFACE_DETAIL_DATA)GlobalAlloc(GPTR, dwRequireSize);
		//deviceDetailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
		//SetupDiGetDeviceInterfaceDetail(hDeviceInfo,
		//								&deviceInfoData,
		//								deviceDetailData,
		//								dwRequireSize,
		//								&dwRequireSize,
		//								NULL);
		//GlobalFree(deviceDetailData);
		strmsg.Format(" ");
		if (PrintLog) AddResponseString(strmsg);
		//if(PrintLog) AddResponseString(strmsg);

		strmsg.Format("m_unDeviceCount-A:%d ", m_unDeviceCount);
		if (PrintLog) AddResponseString(strmsg);

		//Step1 : Get SPDRP_HARDWAREID
		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_HARDWAREID,
			&m_ComPortDeviceArray[m_unDeviceCount].wchHardwareId[0]);
		strmsg.Format("HARDWAREID:%s ", &m_ComPortDeviceArray[m_unDeviceCount].wchHardwareId[0]);
		//↑找Hardware ID → USB\VID_067B&PID_2543&REV_4302&MI_00
		if (PrintLog) AddResponseString(strmsg);
		
		int k = strmsg.Find(srtVIDPID);
		//K =找到的裝置  len (Hardware ID)

		strmsg.Format("srtVIDPID:%s, Len:%d, k:%d", srtVIDPID, srtVIDPID.GetLength(), k);
		if (PrintLog) AddResponseString(strmsg);


		if (srtVIDPID.GetLength()>5) {

			if (k < 0) { //K = 找到的裝置 len (Hardware ID)
				strmsg.Format(" 不是%s, 跳離迴圈", srtVIDPID);
				if (PrintLog) AddResponseString(strmsg);
				continue;

			}
		}



		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_DRIVER,
			&m_ComPortDeviceArray[m_unDeviceCount].wchDriver[0]);
		strmsg.Format("DRIVER:%s ", &m_ComPortDeviceArray[m_unDeviceCount].wchDriver[0]);
		if (PrintLog) AddResponseString(strmsg);

		//bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_ADDRESS, 
		//							&m_ComPortDeviceArray[m_unDeviceCount].wchDeviceAddress[0]);

		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_PHYSICAL_DEVICE_OBJECT_NAME,
			&m_ComPortDeviceArray[m_unDeviceCount].wchPhysicalDeviceObjectName[0]);
		strmsg.Format("DEVICE_OBJECT_NAME:%s ", &m_ComPortDeviceArray[m_unDeviceCount].wchPhysicalDeviceObjectName[0]);
		if (PrintLog) AddResponseString(strmsg);

		//Step2 : Get SPDRP_FRIENDLYNAME 
		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_FRIENDLYNAME,
			&m_ComPortDeviceArray[m_unDeviceCount].wchFriendlyName[0]);
		strmsg.Format("FRIENDLYNAME:%s ", &m_ComPortDeviceArray[m_unDeviceCount].wchFriendlyName[0]);
		if (PrintLog) AddResponseString(strmsg);
		strMsg.Format(_T("%s"), m_ComPortDeviceArray[m_unDeviceCount].wchFriendlyName);
		//cboDevice.AddString(m_ComPortDeviceArray[m_unDeviceCount].wchFriendlyName);
		cboDevice.AddString(strMsg);


		//Step3 : Get SPDRP_LOCATION_PATHS
		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_LOCATION_PATHS,
			&m_ComPortDeviceArray[m_unDeviceCount].wchLocationPath[0]);
		strmsg.Format("LOCATION_PATHS:%s ", &m_ComPortDeviceArray[m_unDeviceCount].wchLocationPath[0]);
		if (PrintLog) AddResponseString(strmsg);

		//Step4 : Get SPDRP_LOCATION_INFORMATION
		bReturn = GetRegistryProperty(hDeviceInfo, devInfoData, SPDRP_LOCATION_INFORMATION,
			&m_ComPortDeviceArray[m_unDeviceCount].wchLocationInfo[0]);
		strmsg.Format("LOCATION_INFORMATION:%s ", &m_ComPortDeviceArray[m_unDeviceCount].wchLocationInfo[0]);
		if (PrintLog) AddResponseString(strmsg);

		m_unDeviceCount++;
		strmsg.Format("m_unDeviceCount-B:%d ", m_unDeviceCount);
		if (PrintLog) AddResponseString(strmsg);
	}
	SetupDiDestroyDeviceInfoList(hDeviceInfo);
	return 0;	//Success
}


BOOL CPL25236GPIODlg::GetRegistryProperty(HDEVINFO hDeviceInfo, SP_DEVINFO_DATA& devInfoData,
	DWORD RegistryProperty, WCHAR* wchBuffer)
{
	LPTSTR buffer = NULL;
	DWORD dwRegDataType;
	DWORD dwRequireSize = 0;
	BOOL bReturn = FALSE;
	//Step1 : Get SPDRP_HARDWAREID
	while (!SetupDiGetDeviceRegistryProperty(hDeviceInfo, &devInfoData, RegistryProperty,
		&dwRegDataType, (PBYTE)buffer, dwRequireSize, &dwRequireSize)) {
		if (GetLastError() == ERROR_INSUFFICIENT_BUFFER)
		{
			// Change the buffer size.
			if (buffer) LocalFree(buffer);
			buffer = (LPTSTR)LocalAlloc(LPTR, dwRequireSize * sizeof(TCHAR));
		}
		else
		{
			// Insert error handling here.
			break;
		}
	}
	//copy Data
	memcpy(wchBuffer, buffer, dwRequireSize);
	//m_ComPortDeviceArray[m_unDeviceCount].dwRegistryType = dwRegDataType;
	if (buffer) LocalFree(buffer);
	dwRequireSize = 0;
	return TRUE;
}


void CPL25236GPIODlg::OnBnClickedButton1()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	CString str = "通訊連接埠 (COM1)";
	CString strCom;
	CString strmsg;
	CString str1 = "PL2523 USB2.0 HS Serial Port_0 (COM8)";
	//AddResponseString(str); //印出通訊連接埠 (COM1)

	int nIndex = str.FindOneOf("("); //抓到(

	strmsg.Format("Index:%d", nIndex); //抓到nlndex=11
	AddResponseString(strmsg); //印出nlndex=11

	
	strmsg = str.Mid(nIndex+1);
	AddResponseString(strmsg);  //COM1

	strmsg = strmsg.TrimRight(")");
	AddResponseString(strmsg);  // 1

	nIndex = str1.FindOneOf("("); //抓到(
	strmsg.Format("Index:%d", nIndex);
	AddResponseString(strmsg); //印出nlndex=31

	strmsg = str1.Mid(nIndex+1);
	AddResponseString(strmsg);  //COM1

	strmsg = strmsg.TrimRight(")");
	AddResponseString(strmsg);  // 1

}

BOOL CPL25236GPIODlg::OnDeviceChange(UINT nEventType, DWORD dwData)
{
	CString str;
	switch (nEventType) {
	case DBT_DEVICEARRIVAL:
	{
		str = "Device Attached!";
		//DeviceOpen();
		if(PrintLog)AddResponseString(str);

		//OnBnClickedButRefresh(); //方法1，尋找所有Com Port
		//OnBnClickedRefresh067b(); //方法2，只找067B
		OnBnClickedRefreshfinal(); //方法3，可以尋找所有或指定尋找
		break;
	}
	case DBT_DEVICEREMOVECOMPLETE:
	{
		str = "Device deattached!";
		//DeviceClose();
		if (PrintLog)AddResponseString(str);
		break;
	}
	}

	return TRUE;
}


void CPL25236GPIODlg::OnBnClickedChkP310Ce()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 10;
	int  Channel = 3;
	BOOL enable;
	BOOL CHK = 0;
	int errCode;
	char str[MAX_PATH];

	if (mc_P3_10_CE.GetCheck()) {

		enable = 1;  // CE enable, GPIO:input mode
		CHK = 1;

		mc_P3_10_OE.EnableWindow(1);
		mc_P3_10_OE.SetCheck(0);
		mc_P3_10_Get.EnableWindow(1);

	}
	else {

		enable = 0;  // CE disable, 回復原狀

		mc_P3_10_OE.EnableWindow(0);
		mc_P3_10_OE.SetCheck(0);
		mc_P3_10_Get.EnableWindow(0);

	}

	mc_P3_10_Set.EnableWindow(0);
	mc_P3_10_edit.EnableWindow(0);

	//if (CHK)  PL2523_GPIO_CE_Config(m_hCOM, 0x0010, 0x0003, enable); 

	if ((errCode = PL2523_6GPIO_CE_Config(m_hCOM, 0x000A, 0x0003, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_CE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_CE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);

	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedChkP310Oe()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	DWORD nBytes;
	int PortNumber = 10;
	int  Channel = 3;
	BOOL enable;
	BOOL CHK = 0;
	int errCode;
	char str[MAX_PATH];

	if (mc_P3_10_OE.GetCheck()) {

		enable = 1;  // OE enable, GPIO:output mode
		CHK = 1;

		mc_P3_10_Get.EnableWindow(0);
		mc_P3_10_Set.EnableWindow(1);
		mc_P3_10_edit.EnableWindow(1);
	}
	else {

		enable = 0;  // OE disable, GPIO:input mode

		mc_P3_10_Get.EnableWindow(1);
		mc_P3_10_Set.EnableWindow(0);
		mc_P3_10_edit.EnableWindow(0);
	}

	//if (CHK) PL2523_6GPIO_OE_Config(m_hCOM, 0x0010, 0x0003, enable); 

	if ((errCode = PL2523_6GPIO_OE_Config(m_hCOM, 0x000A, 0x0003, enable)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_OE_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	str_Response = PL2523_OE_Printlog(errCode, enable, PortNumber, Channel);
	AddResponseString(str_Response);
	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedBtnGetP310()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	int errCode;
	char str[MAX_PATH];

	//PL2523_6GPIO_GET_Config(0x0010, 0x0003);

	if ((errCode = PL2523_6GPIO_GET_Config(m_hCOM, 0x000A, 0x0003, &val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_GET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}

	else {
		str_Response = PL2523_Getval_Printlog(0x000A, 0x0003, val);
		AddResponseString(str_Response);
	}

	UpdateData(FALSE);
}


void CPL25236GPIODlg::OnBnClickedBtnSetP310()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	UpdateData();
	int errCode;
	char str[MAX_PATH];

	//val = (BYTE)atoi(mv_P3_10_edit);  //文字轉int
	val = mv_P3_10_edit;

	//PL2523_6GPIO_SET_Config(0x0010, 0x003, val);
	if ((errCode = PL2523_6GPIO_SET_Config(m_hCOM, 0x000A, 0x0003, val)) != STATUS_SUCCESS) {
		wsprintf(str, "PL2523_GPIO_SET_Config Failed! - %d", errCode);
		MessageBox(str, "ERROR", MB_OK | MB_ICONSTOP);
		return;
	}
	else {
		str_Response = PL2523_Setval_Printlog(0x000A, 0x0003, val);
		AddResponseString(str_Response);
	}
	UpdateData(FALSE);
}

//2022.11.14 add 只尋找067B Com Port
void CPL25236GPIODlg::OnBnClickedRefresh067b()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	Refresh_067B();
}


void CPL25236GPIODlg::OnBnClickedRefreshfinal()
{
	// TODO: 在此加入控制項告知處理常式程式碼
	Refresh_Final();
}
